"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var client_1 = require("./client");
var reconnecting_websocket_1 = require("reconnecting-websocket");
exports.attachToGun = function (Gun, options) {
    var _a = (options || {}).peers, peers = _a === void 0 ? [] : _a;
    Gun.on('create', function (db) {
        var http = (Gun.http = db.http = new client_1.GunHttpClient(Gun, options));
        function receive(msg) {
            try {
                db.on('in', __assign({}, JSON.parse(msg.data || msg), { from: 'websocket' }));
            }
            catch (e) {
                console.error('Websocket error', e.stack || e);
            }
        }
        var sockets = peers.map(function (url) {
            var ws = new reconnecting_websocket_1.default(url, []);
            ws.addEventListener('message', receive);
            return ws;
        });
        db.on('get', function (request) {
            return __awaiter(this, void 0, void 0, function () {
                var _a, dedupId, get, soul, result, err_1;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            this.to.next(request);
                            if (!request) {
                                return [2 /*return*/];
                            }
                            dedupId = request['#'];
                            get = request.get;
                            soul = get['#'];
                            _b.label = 1;
                        case 1:
                            _b.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, http.get(soul)];
                        case 2:
                            result = _b.sent();
                            db.on('in', {
                                '@': dedupId,
                                put: result
                                    ? (_a = {},
                                        _a[soul] = result,
                                        _a) : null,
                                from: 'http',
                                err: null
                            });
                            return [3 /*break*/, 4];
                        case 3:
                            err_1 = _b.sent();
                            console.error('error', err_1.stack || err_1);
                            db.on('in', {
                                '@': dedupId,
                                put: null,
                                from: 'http',
                                err: err_1
                            });
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        });
        db.on('put', function (request) {
            return __awaiter(this, void 0, void 0, function () {
                var i;
                return __generator(this, function (_a) {
                    this.to.next(request);
                    if (!request ||
                        request.from === 'http' ||
                        request.from === 'websocket' ||
                        request.from === 'local') {
                        return [2 /*return*/];
                    }
                    for (i = 0; i < sockets.length; i++) {
                        try {
                            sockets[i].send(JSON.stringify(request));
                        }
                        catch (e) {
                            console.error('WebSocket error', e.stack || e);
                        }
                    }
                    return [2 /*return*/];
                });
            });
        });
        this.to.next(db);
    });
};
//# sourceMappingURL=gun.js.map